#include "PGM.h"

#include <cstdlib>

namespace PGM {

	void skipcomments( std::ifstream& file )
	{
		std::string line = "";

		while( file.peek() == '#' )
			std::getline( file, line );
	}

	/* this is a very bad way to parse pgm ... for our purpose it is enough */
	void read( const char* filename, unsigned char** ptr, int* w, int* h )
	{
		std::ifstream file( filename );
		int val;
		std::string line = "";

		file >> std::skipws;
		std::getline( file, line );
		if( line.compare( "P2" ) != 0 ) {
			std::cerr << "File invalid" << std::endl;
			std::exit( EXIT_FAILURE );
		}

		skipcomments( file );
		file >> *w >> *h;
		skipcomments( file );
		file >> val; // unused read
		skipcomments( file );

		// now get the data
		// allocate w times h data
		int n = *w * *h;
		unsigned char* data = new unsigned char[ n ];
		*ptr = data;
		while( n-- ) {
			file >> val;
			*data++ = val;
		}
	}

	void write( const char* filename, unsigned char* ptr, int w, int h )
	{
		std::ofstream file( filename, std::ios_base::trunc );
		file << "P2" << std::endl;
		file << w << " " << h << std::endl << "255" << std::endl;

		int n = w * h;
		int c = 0;
		while( n-- ) {
			file << ( int ) *ptr++ << " ";
			if( c++ == 80 ) { // after every 80th pixel start a new line
				file << std::endl;
				c = 0;
			}
		}
	}
}
