#include "PGM.h"
#include <cmath>

unsigned char* filledcircle( int w, int h, int cx, int cy, int radius )
{
	unsigned char* ret = new unsigned char[ w * h ];

	for( int y = 0; y < h; y++ ) {
		for( int x = 0; x < w; x++ ) {
			float xpos = ( float ) x - cx;
			float ypos = ( float ) y - cy;
			float r = sqrt( xpos * xpos + ypos * ypos );
			if( r <= radius )
				ret[ y * w + x ] = 255;
			else
				ret[ y * w + x ] = 0;
		}
	}

	return ret;
}

int main()
{
	unsigned char* data;
	int w, h;

	w = h = 512;
	data = filledcircle( w, h, 256, 256, 100 );

	PGM::write( "circle.pgm", data, w, h );

	// delete the data
}
