#ifndef HANOI_H
#define HANOI_H

#include "Rod.h"

class Hanoi
{
	public:
		Hanoi( int numdisc ) : _rod0( numdisc ), _rod1( 0 ), _rod2( 0 )
		{
		}

		void print()
		{
			std::cout << "Rod 0:" << std::endl;
			_rod0.print();
			std::cout << "Rod 1:" << std::endl;
			_rod1.print();
			std::cout << "Rod 2:" << std::endl;
			_rod2.print();
			std::cout << std::endl;
		}

		void solve()
		{
			print();
			solveRecursive( _rod0, _rod1, _rod2, _rod0.numDiscs() );
		}

	private:
		void solveRecursive( Rod& rodsrc, Rod& temp, Rod& roddst, int n )
		{
			if( n > 0 ) {
				solveRecursive( rodsrc, roddst, temp, n - 1 );
				roddst.push( rodsrc.pop() );
				print();
				solveRecursive( temp, rodsrc, roddst, n - 1 );
			}
		}

		Rod _rod0;
		Rod _rod1;
		Rod _rod2;
};

#endif

